openapi: 3.0.0
info:
  title: SAP API
  version: 1.0.0
servers:
- url: http://localhost:8080
paths:
  /rfc/PRGN_STRU_SAVE_NODES:
    post:
      tags:
      - PRGN_STRUCTURE
      operationId: /rfc/PRGN_STRU_SAVE_NODES
      requestBody:
        content:
          application/json:
            schema:
              properties:
                ACTIVITY_GROUP:
                  type: string
                  maxLength: 30
                AUTHORITY_CHECK:
                  type: string
                  default: ' '
                  maxLength: 1
                  description: Customized ('C') or standard menu ('S') flag
                ENQUEUE:
                  type: string
                  default: ' '
                  maxLength: 1
                  description: Customized ('C') or standard menu ('S') flag
                ONLY_SY_LANGU:
                  type: string
                  default: ' '
                  maxLength: 1
                  description: Customized ('C') or standard menu ('S') flag
                SOURCE_AGR_TIME:
                  type: object
                  properties:
                    MANDT:
                      type: string
                      maxLength: 3
                      description: Client ID of Current User
                    AGR_NAME:
                      type: string
                      maxLength: 30
                      description: Role Name
                    AGR_TYPE:
                      type: string
                      maxLength: 10
                      description: 'Time Stamp for Role (Menu, Authorization Data, Target Sys.)  enumValues: SYSTTARTMP=Time Stamp for Assignment of Target System to a Single Role,MENU=Time Stamp for Menu,PROFILE=Time Stamp for Authorization Data,COL_AGR_T=Time Stamp for Assignment of Single Roles to Composite Roles'
                      enum:
                      - SYSTTARTMP
                      - MENU
                      - PROFILE
                      - COL_AGR_T
                    CREATE_USR:
                      type: string
                      maxLength: 12
                      description: User Name
                    CREATE_DAT:
                      type: string
                      format: date
                      description: Current Date of Application Server
                    CREATE_TIM:
                      type: string
                      maxLength: 6
                      description: Current Time of Application Server
                    CREATE_TMP:
                      type: integer
                      format: int64
                      description: UTC Time Stamp in Short Form (YYYYMMDDhhmmss)
                    CHANGE_USR:
                      type: string
                      maxLength: 12
                      description: Last changed by
                    CHANGE_DAT:
                      type: string
                      format: date
                      description: Date of last change
                    CHANGE_TIM:
                      type: string
                      maxLength: 6
                      description: Last Changed At
                    CHANGE_TMP:
                      type: integer
                      format: int64
                      description: UTC Time Stamp in Short Form (YYYYMMDDhhmmss)
                    ATTRIBUTES:
                      type: string
                      maxLength: 10
                      description: Attributes of the menu
                USE_GLOBAL_TABLES:
                  type: string
                  default: X
                  maxLength: 1
                WARNING_POPUP:
                  type: string
                  default: ' '
                  maxLength: 1
                  description: Customized ('C') or standard menu ('S') flag
                MENU_HIERARCHY:
                  type: array
                  items:
                    type: object
                    properties:
                      OBJECT_ID:
                        type: integer
                        format: int64
                        description: Counter for Menu ID
                      PARENT_ID:
                        type: integer
                        format: int64
                        description: Counter for Menu ID
                      FOLDER:
                        type: string
                        maxLength: 1
                        description: Customized ('C') or standard menu ('S') flag
                      MENU_LEVEL:
                        type: integer
                        format: int64
                        description: Level in the menu
                      SORT_ORDER:
                        type: integer
                        format: int64
                        description: Counter for Menu ID
                      STRING1:
                        type: string
                        maxLength: 255
                        description: URL for the SAP Portal
                      STRING2:
                        type: string
                        maxLength: 255
                        description: URL for the SAP Portal
                      ICON:
                        type: string
                        maxLength: 128
                        description: Icons for Role Menu Entries
                      FLAGS:
                        type: string
                        maxLength: 16
                        description: Attributes for Menu Entry
                MENU_TEXTS:
                  type: array
                  items:
                    type: object
                    properties:
                      SPRAS:
                        type: string
                        maxLength: 1
                        description: Language of menu texts
                      OBJECT_ID:
                        type: integer
                        format: int64
                        description: Counter for Menu ID
                      TEXT:
                        type: string
                        maxLength: 80
                        description: Menu entry text
                      DESCRIPTION:
                        type: string
                        maxLength: 255
                        description: Long Text for Menu Entry
              required:
              - ACTIVITY_GROUP
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                properties:
                  MENU_HIERARCHY:
                    type: array
                    items:
                      type: object
                      properties:
                        OBJECT_ID:
                          type: integer
                          format: int64
                          description: Counter for Menu ID
                        PARENT_ID:
                          type: integer
                          format: int64
                          description: Counter for Menu ID
                        FOLDER:
                          type: string
                          maxLength: 1
                          description: Customized ('C') or standard menu ('S') flag
                        MENU_LEVEL:
                          type: integer
                          format: int64
                          description: Level in the menu
                        SORT_ORDER:
                          type: integer
                          format: int64
                          description: Counter for Menu ID
                        STRING1:
                          type: string
                          maxLength: 255
                          description: URL for the SAP Portal
                        STRING2:
                          type: string
                          maxLength: 255
                          description: URL for the SAP Portal
                        ICON:
                          type: string
                          maxLength: 128
                          description: Icons for Role Menu Entries
                        FLAGS:
                          type: string
                          maxLength: 16
                          description: Attributes for Menu Entry
                  MENU_TEXTS:
                    type: array
                    items:
                      type: object
                      properties:
                        SPRAS:
                          type: string
                          maxLength: 1
                          description: Language of menu texts
                        OBJECT_ID:
                          type: integer
                          format: int64
                          description: Counter for Menu ID
                        TEXT:
                          type: string
                          maxLength: 80
                          description: Menu entry text
                        DESCRIPTION:
                          type: string
                          maxLength: 255
                          description: Long Text for Menu Entry
        '400':
          description: Bad request.
        5XX:
          description: Unexpected error.
